<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: cert_vfy.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">cert_vfy.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="cert__vfy_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * PKCS #11 PAM Login Module</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright (C) 2003 Mario Strasser &lt;mast@gmx.net&gt;,</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * This library is free software; you can redistribute it and/or</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * modify it under the terms of the GNU Lesser General Public</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * License as published by the Free Software Foundation; either</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * version 2.1 of the License, or (at your option) any later version.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * This library is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * Lesser General Public License for more details.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> * $Id$</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#ifndef __CERT_VFY_H_</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#define __CERT_VFY_H_</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="cert__st_8h.html">cert_st.h</a>&quot;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8">   32</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8affcde4b8f007980bd93b94b4c66e2fb3">   34</a></span>&#160;        <a class="code" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8affcde4b8f007980bd93b94b4c66e2fb3">CRLP_NONE</a>,</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8a95f4bf39b70f87ab4afcb1ee77f974f2">   36</a></span>&#160;        <a class="code" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8a95f4bf39b70f87ab4afcb1ee77f974f2">CRLP_ONLINE</a>,</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8ab4927411f8e4d31e007a8040f036d713">   38</a></span>&#160;        <a class="code" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8ab4927411f8e4d31e007a8040f036d713">CRLP_OFFLINE</a>,</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8aac2d1ab539295c0012e8f77ca8504264">   40</a></span>&#160;        <a class="code" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8aac2d1ab539295c0012e8f77ca8504264">CRLP_AUTO</a></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        } <a class="code" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8">crl_policy_t</a>;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5">   43</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5af5419e3493ea2cb3b1c60c657cfe48ff">   44</a></span>&#160;        <a class="code" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5af5419e3493ea2cb3b1c60c657cfe48ff">OCSP_NONE</a>,</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5adb13787add7b772383a0b376cc9df39e">   45</a></span>&#160;        <a class="code" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5adb13787add7b772383a0b376cc9df39e">OCSP_ON</a></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        } <a class="code" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5">ocsp_policy_t</a>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="structcert__policy__st.html">   48</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structcert__policy__st.html">cert_policy_st</a> {</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="structcert__policy__st.html#ae3020b82e38c451708f77b144b9a3f66">   49</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="structcert__policy__st.html#ae3020b82e38c451708f77b144b9a3f66">ca_policy</a>;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="structcert__policy__st.html#a38fcc862c2f7febf4a2df328202807fa">   50</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="structcert__policy__st.html#a38fcc862c2f7febf4a2df328202807fa">crl_policy</a>;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="structcert__policy__st.html#af8c62c98042d78f77e0bf25647957f87">   51</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="structcert__policy__st.html#af8c62c98042d78f77e0bf25647957f87">signature_policy</a>;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="structcert__policy__st.html#a543a7f5cec5587e13bb19583cfca54b1">   52</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structcert__policy__st.html#a543a7f5cec5587e13bb19583cfca54b1">ca_dir</a>;</div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="structcert__policy__st.html#a25db4ed05290154fb24712e8a5495a27">   53</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structcert__policy__st.html#a25db4ed05290154fb24712e8a5495a27">crl_dir</a>;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="structcert__policy__st.html#afe1bb14b9d79f31bc1a7e12aa4372572">   54</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structcert__policy__st.html#afe1bb14b9d79f31bc1a7e12aa4372572">nss_dir</a>;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="structcert__policy__st.html#a04b039659f36971eb3d935ace803572e">   55</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="structcert__policy__st.html#a04b039659f36971eb3d935ace803572e">ocsp_policy</a>;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;};</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#ifndef __CERT_VFY_C</span></div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">   59</a></span>&#160;<span class="preprocessor">#define CERTVFY_EXTERN extern</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#define CERTVFY_EXTERN</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<a class="code" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a> <span class="keywordtype">int</span> <a class="code" href="cert__vfy_8h.html#a71048924d0302ee24e5e026a51c9d7c3">verify_certificate</a>(X509 * x509, <a class="code" href="structcert__policy__st.html">cert_policy</a> *policy);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<a class="code" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a> <span class="keywordtype">int</span> <a class="code" href="cert__vfy_8h.html#a780e20dcfed4d1079e15f4480310992f">verify_signature</a>(X509 * x509, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *data, <span class="keywordtype">int</span> data_length, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> **signature, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *signature_length);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#undef CERTVFY_EXTERN</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* __CERT_VFY_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="structcert__policy__st_html"><div class="ttname"><a href="structcert__policy__st.html">cert_policy_st</a></div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00048">cert_vfy.h:48</a></div></div>
<div class="ttc" id="structcert__policy__st_html_a543a7f5cec5587e13bb19583cfca54b1"><div class="ttname"><a href="structcert__policy__st.html#a543a7f5cec5587e13bb19583cfca54b1">cert_policy_st::ca_dir</a></div><div class="ttdeci">const char * ca_dir</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00052">cert_vfy.h:52</a></div></div>
<div class="ttc" id="structcert__policy__st_html_af8c62c98042d78f77e0bf25647957f87"><div class="ttname"><a href="structcert__policy__st.html#af8c62c98042d78f77e0bf25647957f87">cert_policy_st::signature_policy</a></div><div class="ttdeci">int signature_policy</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00051">cert_vfy.h:51</a></div></div>
<div class="ttc" id="structcert__policy__st_html_a25db4ed05290154fb24712e8a5495a27"><div class="ttname"><a href="structcert__policy__st.html#a25db4ed05290154fb24712e8a5495a27">cert_policy_st::crl_dir</a></div><div class="ttdeci">const char * crl_dir</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00053">cert_vfy.h:53</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_ae1c349e0e76aa063dd7bb358e48c53c5af5419e3493ea2cb3b1c60c657cfe48ff"><div class="ttname"><a href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5af5419e3493ea2cb3b1c60c657cfe48ff">OCSP_NONE</a></div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00044">cert_vfy.h:44</a></div></div>
<div class="ttc" id="cert__st_8h_html"><div class="ttname"><a href="cert__st_8h.html">cert_st.h</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_ab77df6bf5287800e154be1018542aab8ab4927411f8e4d31e007a8040f036d713"><div class="ttname"><a href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8ab4927411f8e4d31e007a8040f036d713">CRLP_OFFLINE</a></div><div class="ttdoc">Retrieve CRL from local filesystem. </div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00038">cert_vfy.h:38</a></div></div>
<div class="ttc" id="structcert__policy__st_html_afe1bb14b9d79f31bc1a7e12aa4372572"><div class="ttname"><a href="structcert__policy__st.html#afe1bb14b9d79f31bc1a7e12aa4372572">cert_policy_st::nss_dir</a></div><div class="ttdeci">const char * nss_dir</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00054">cert_vfy.h:54</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_a780e20dcfed4d1079e15f4480310992f"><div class="ttname"><a href="cert__vfy_8h.html#a780e20dcfed4d1079e15f4480310992f">verify_signature</a></div><div class="ttdeci">CERTVFY_EXTERN int verify_signature(X509 *x509, unsigned char *data, int data_length, unsigned char **signature, unsigned long *signature_length)</div><div class="ttdoc">Verify signature of provided data. </div></div>
<div class="ttc" id="cert__vfy_8h_html_ab77df6bf5287800e154be1018542aab8affcde4b8f007980bd93b94b4c66e2fb3"><div class="ttname"><a href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8affcde4b8f007980bd93b94b4c66e2fb3">CRLP_NONE</a></div><div class="ttdoc">Do not perform any CRL verification. </div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00034">cert_vfy.h:34</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_ae1c349e0e76aa063dd7bb358e48c53c5adb13787add7b772383a0b376cc9df39e"><div class="ttname"><a href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5adb13787add7b772383a0b376cc9df39e">OCSP_ON</a></div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00045">cert_vfy.h:45</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_a4d252cfaa5d28f44e4c09b8cc167cf5c"><div class="ttname"><a href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a></div><div class="ttdeci">#define CERTVFY_EXTERN</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00059">cert_vfy.h:59</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_ab77df6bf5287800e154be1018542aab8"><div class="ttname"><a href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8">crl_policy_t</a></div><div class="ttdeci">crl_policy_t</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00032">cert_vfy.h:32</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_ab77df6bf5287800e154be1018542aab8aac2d1ab539295c0012e8f77ca8504264"><div class="ttname"><a href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8aac2d1ab539295c0012e8f77ca8504264">CRLP_AUTO</a></div><div class="ttdoc">Try CRL check online, else ofline, else fail. </div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00040">cert_vfy.h:40</a></div></div>
<div class="ttc" id="structcert__policy__st_html_ae3020b82e38c451708f77b144b9a3f66"><div class="ttname"><a href="structcert__policy__st.html#ae3020b82e38c451708f77b144b9a3f66">cert_policy_st::ca_policy</a></div><div class="ttdeci">int ca_policy</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00049">cert_vfy.h:49</a></div></div>
<div class="ttc" id="structcert__policy__st_html_a04b039659f36971eb3d935ace803572e"><div class="ttname"><a href="structcert__policy__st.html#a04b039659f36971eb3d935ace803572e">cert_policy_st::ocsp_policy</a></div><div class="ttdeci">int ocsp_policy</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00055">cert_vfy.h:55</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_ab77df6bf5287800e154be1018542aab8a95f4bf39b70f87ab4afcb1ee77f974f2"><div class="ttname"><a href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8a95f4bf39b70f87ab4afcb1ee77f974f2">CRLP_ONLINE</a></div><div class="ttdoc">Retrieve CRL from CA site. </div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00036">cert_vfy.h:36</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_ae1c349e0e76aa063dd7bb358e48c53c5"><div class="ttname"><a href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5">ocsp_policy_t</a></div><div class="ttdeci">ocsp_policy_t</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00043">cert_vfy.h:43</a></div></div>
<div class="ttc" id="structcert__policy__st_html_a38fcc862c2f7febf4a2df328202807fa"><div class="ttname"><a href="structcert__policy__st.html#a38fcc862c2f7febf4a2df328202807fa">cert_policy_st::crl_policy</a></div><div class="ttdeci">int crl_policy</div><div class="ttdef"><b>Definition:</b> <a href="cert__vfy_8h_source.html#l00050">cert_vfy.h:50</a></div></div>
<div class="ttc" id="cert__vfy_8h_html_a71048924d0302ee24e5e026a51c9d7c3"><div class="ttname"><a href="cert__vfy_8h.html#a71048924d0302ee24e5e026a51c9d7c3">verify_certificate</a></div><div class="ttdeci">CERTVFY_EXTERN int verify_certificate(X509 *x509, cert_policy *policy)</div><div class="ttdoc">Verify provided certificate, and if needed, CRL. </div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
